>{-# OPTIONS -fglasgow-exts #-}

> module ArrowTransformer where

> import Arrow

Embedding old arrows in new ones.

> class (Arrow a, Arrow (f a)) => ArrowTransformer f a where
>	lift :: a b c -> f a b c

A variant that does something once and then distributes the result

> class ArrowTransformer f a => ArrowOnce f a where
>	once :: a () b -> f a () b

An arrow functor lifts such embeddings.

> class ArrowFunctor f where
>	arrowmap :: (forall b c. a b c -> a' b c) ->
>			f a b' c' -> f a' b' c'

Functors that extend to arrows.

> class (Arrow a, Functor f) => GenFunctor a f where
>	genmap :: a b c -> a (f b) (f c)

Instances for standard types

> instance Functor ((,) a) where
>	fmap f (x, y) = (x, f y)

> instance Arrow a => GenFunctor a ((,) b) where
>	genmap = second

> instance Functor (Either ex) where
>	fmap f (Left ex) = Left ex
>	fmap f (Right y) = Right (f y)

> instance ArrowChoice a => GenFunctor a (Either ex) where
>	genmap = right
